//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "port.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
TCasovac Timer;
TPort Port;
HWND hwndWinamp;
TButton *stisknuto;
bool DCD,DSR,CTS,RI;
union
{
  struct Tsave
  {
    bool started,priority;
    byte com,af,bf,cf,df,ah,bh,ch,dh;
  } kus;
  char cele[sizeof(Tsave)];
} save;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  save.kus.started=false;save.kus.priority=false;save.kus.com=0;
  save.kus.af=0;save.kus.bf=6;save.kus.cf=7;save.kus.df=1;
  save.kus.ah=false;save.kus.bh=false;save.kus.ch=false;save.kus.dh=false;

  HANDLE fh=CreateFile("winampc.cfg",GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
  if (fh!=INVALID_HANDLE_VALUE)
  {
    DWORD kolik;
    ReadFile(fh,save.cele,sizeof(save),&kolik,NULL);
    if (kolik!=sizeof(save))
    {
      Application->MessageBox("Can't read settings! Deleting cfg file.","Error!",MB_OK|MB_ICONWARNING);
      CloseHandle(fh);
      if (FileExists("winampc.cfg")) DeleteFile("winampc.cfg");
    }
    CloseHandle(fh);
  }

  DCD=false;DSR=false;CTS=false;RI=false;
  ComboBox2->Items->Add("previous");
  ComboBox2->Items->Add("next");
  ComboBox2->Items->Add("forward");
  ComboBox2->Items->Add("backward");
  ComboBox2->Items->Add("play");
  ComboBox2->Items->Add("pause");
  ComboBox2->Items->Add("play/pause");
  ComboBox2->Items->Add("stop");
  ComboBox2->ItemIndex=save.kus.af;
  ComboBox3->Items->Add("previous");
  ComboBox3->Items->Add("next");
  ComboBox3->Items->Add("forward");
  ComboBox3->Items->Add("backward");
  ComboBox3->Items->Add("play");
  ComboBox3->Items->Add("pause");
  ComboBox3->Items->Add("play/pause");
  ComboBox3->Items->Add("stop");
  ComboBox3->ItemIndex=save.kus.bf;
  ComboBox4->Items->Add("previous");
  ComboBox4->Items->Add("next");
  ComboBox4->Items->Add("forward");
  ComboBox4->Items->Add("backward");
  ComboBox4->Items->Add("play");
  ComboBox4->Items->Add("pause");
  ComboBox4->Items->Add("play/pause");
  ComboBox4->Items->Add("stop");
  ComboBox4->ItemIndex=save.kus.cf;
  ComboBox5->Items->Add("previous");
  ComboBox5->Items->Add("next");
  ComboBox5->Items->Add("forward");
  ComboBox5->Items->Add("backward");
  ComboBox5->Items->Add("play");
  ComboBox5->Items->Add("pause");
  ComboBox5->Items->Add("play/pause");
  ComboBox5->Items->Add("stop");
  ComboBox5->ItemIndex=save.kus.df;

  ComboBox1->ItemIndex=save.kus.com;
  CheckBox1->Checked=save.kus.priority;
  CheckBox2->Checked=save.kus.ah;
  CheckBox3->Checked=save.kus.bh;
  CheckBox4->Checked=save.kus.ch;
  CheckBox5->Checked=save.kus.dh;

  if (CheckBox1->Checked) Priorita(1);
  else Priorita(2);

  hwndWinamp = FindWindow("Winamp v1.x",NULL);
  stisknuto=NULL;
  Nazev();

  if (save.kus.started) Button10Click(this);
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1()
{
  Timer.Stop();
  Port.Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Nazev()
{
  char this_title[2048],*p;
//  AnsiString time;
  GetWindowText(hwndWinamp,this_title,sizeof(this_title));
  p = this_title+strlen(this_title)-8;
  while (p >= this_title)
  {
    if (!strnicmp(p,"- Winamp",8)) break;
    p--;
  }
  if (p >= this_title) p--;
  while (p >= this_title && *p == ' ') p--;
  *++p=0;
//  int ret=SendMessage(hwndWinamp, WM_USER, 0, 105);
//  if (ret==-1) time="";
//  else time=" <"+AnsiString(ret)+">";
  if (!hwndWinamp) Label1->Caption="WinAmp is not started!";
  else Label1->Caption=this_title; //+time;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonClick(TObject *Sender)
{
  int akce=0;
  hwndWinamp = FindWindow("Winamp v1.x",NULL);
/*  if (Sender==Button11)
  {
    SendMessage(hwndWinamp, WM_USER, 255, 122);
    Label2->Caption=ret;
  } else
  {
*/
    if (Sender==Button1) akce=40144;
    if (Sender==Button2) akce=40045;
    if (Sender==Button3) akce=40046;
    if (Sender==Button4) akce=40047;
    if (Sender==Button5) akce=40044;
    if (Sender==Button6) akce=40048;
    if (Sender==Button7) akce=40148;
    if (Sender==Button8) akce=40058;
    if (Sender==Button9) akce=40059;
    if (akce!=0 && hwndWinamp) SendMessage(hwndWinamp, WM_COMMAND, akce, 0);
    Nazev();
//  }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  stisknuto=(TButton*) Sender;
  if (Sender==Button8 || Sender==Button9) Timer1->Interval=10;
  else Timer1->Interval=100;
  Form1->ButtonClick(stisknuto);
  if (hwndWinamp) Timer1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
  Timer1->Enabled=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  if (stisknuto) Form1->ButtonClick(stisknuto);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
 Nazev();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button10Click(TObject *Sender)
{
 if (Button10->Caption=="STOP")
 {
   Button10->Caption="START";
   Port.TxD(false);
   save.kus.started=false;
   Timer.Stop();
   ComboBox1->Enabled=true;ComboBox2->Enabled=true;ComboBox3->Enabled=true;
   ComboBox4->Enabled=true;ComboBox5->Enabled=true;
   CheckBox2->Enabled=true;CheckBox3->Enabled=true;
   CheckBox4->Enabled=true;CheckBox5->Enabled=true;
 } else
 {
   Button10->Caption="STOP";
   if (!Port.Opened())
   {
     char com[5];
     strcpy(com,ComboBox1->Items->Strings[ComboBox1->ItemIndex].c_str());
     if (!Port.Open(com))
     {
       Application->MessageBox("Can't open selected port!","Error!",MB_OK|MB_ICONWARNING);
       return;
     }
   }
   if (Port.Opened())
   {
     Port.DTR(true);
     Port.TxD(true);
     save.kus.started=true;
     Timer.Start(10);
     ComboBox1->Enabled=false;ComboBox2->Enabled=false;ComboBox3->Enabled=false;
     ComboBox4->Enabled=false;ComboBox5->Enabled=false;
     CheckBox2->Enabled=false;CheckBox3->Enabled=false;
     CheckBox4->Enabled=false;CheckBox5->Enabled=false;
   }
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PortObsluha(int i)
{
   int ret;
   switch (i)
   {
     case 0: ButtonClick(Button5);break; // previous
     case 1: ButtonClick(Button6);break; // next
     case 2: ButtonClick(Button7);break; // forward
     case 3: ButtonClick(Button1);break; // backward
     case 4: ButtonClick(Button2);break; // play
     case 5: ButtonClick(Button3);break; // pause
     case 6:                             // play/pause
          ret=SendMessage(hwndWinamp,WM_USER,0,104);
          if (ret==1) ButtonClick(Button3); // play
          else ButtonClick(Button2); //pause
          break;
     case 7: ButtonClick(Button4);break; // stop
   }
}

void __fastcall TForm1::MSG(TMessage& Message)
{
  if (Message.LParam==1 && Port.Opened()) // casovac
  {
    if (Port.DCD())
    {
      if (!DCD || CheckBox2->Checked) PortObsluha(ComboBox2->ItemIndex);
      DCD=true;
    } else DCD=false;
    if (Port.DSR())
    {
      if (!DSR || CheckBox3->Checked) PortObsluha(ComboBox3->ItemIndex);
      DSR=true;
    } else DSR=false;
    if (Port.CTS())
    {
      if (!CTS || CheckBox4->Checked) PortObsluha(ComboBox4->ItemIndex);
      CTS=true;
    } else CTS=false;
    if (Port.RI())
    {
      if (!RI || CheckBox5->Checked) PortObsluha(ComboBox5->ItemIndex);
      RI=true;
    } else RI=false;
  }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::GroupBoxDblClick(TObject *Sender)
{
  TGroupBox* velHandle[3]={GroupBox1,GroupBox2,GroupBox3};
  int velShow[3]={33,49,137};
  int velHide=12;

  int i;
  TGroupBox *GSender;
  if (Sender==GroupBox1) i=0;
  else if (Sender==GroupBox2) i=1;
  else if (Sender==GroupBox3) i=2;
  else return;
  GSender=(TGroupBox*)Sender;
  if (GSender->Height!=velHide)
  {
    GSender->Height=velHide;
    for (int f=i+1;f<sizeof(velShow)/sizeof(velShow[0]);f++)
    {
      velHandle[f]->Top=velHandle[f]->Top-velShow[i]+velHide;
    }
    Form1->ClientHeight=Form1->ClientHeight-velShow[i]+velHide;
    Label7->Top=Label7->Top-velShow[i]+velHide;
    Label8->Top=Label8->Top-velShow[i]+velHide;
    Label9->Top=Label9->Top-velShow[i]+velHide;
  }
  else
  {
    GSender->Height=velShow[i];
    for (int f=i+1;f<sizeof(velShow)/sizeof(velShow[0]);f++)
    {
      velHandle[f]->Top=velHandle[f]->Top+velShow[i]-velHide;
    }
    Form1->ClientHeight=Form1->ClientHeight+velShow[i]-velHide;
    Label7->Top=Label7->Top+velShow[i]-velHide;
    Label8->Top=Label8->Top+velShow[i]-velHide;
    Label9->Top=Label9->Top+velShow[i]-velHide;
  }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
  if (CheckBox1->Checked) Priorita(1);
  else Priorita(2);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LabelDblClick(TObject *Sender)
{
 if (Sender==Label3) PortObsluha(ComboBox2->ItemIndex);
 if (Sender==Label4) PortObsluha(ComboBox3->ItemIndex);
 if (Sender==Label5) PortObsluha(ComboBox4->ItemIndex);
 if (Sender==Label6) PortObsluha(ComboBox5->ItemIndex);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Label8Click(TObject *Sender)
{
  ShellExecute(0, "open", "mailto:jgs@seznam.cz", "", "", SW_SHOWNORMAL);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  if (!CheckBox6->Checked) return;
  save.kus.priority=CheckBox1->Checked;
  save.kus.com=ComboBox1->ItemIndex;
  save.kus.af=ComboBox2->ItemIndex;save.kus.bf=ComboBox3->ItemIndex;
  save.kus.cf=ComboBox4->ItemIndex;save.kus.df=ComboBox5->ItemIndex;
  save.kus.ah=CheckBox2->Checked;save.kus.bh=CheckBox3->Checked;
  save.kus.ch=CheckBox4->Checked;save.kus.dh=CheckBox5->Checked;

  HANDLE fh=CreateFile("winampc.cfg",GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
  if (fh==INVALID_HANDLE_VALUE)
  {
    Application->MessageBox("Can't save settings!","Error!",MB_OK|MB_ICONWARNING);
    return;
  }
  DWORD kolik;
  WriteFile(fh,save.cele,sizeof(save),&kolik,NULL);
  if (kolik!=sizeof(save))
  {
    Application->MessageBox("Can't save settings!","Error!",MB_OK|MB_ICONWARNING);
    CloseHandle(fh);
    if (FileExists("winampc.cfg")) DeleteFile("winampc.cfg");
    return;
  }
  CloseHandle(fh);
}
//---------------------------------------------------------------------------

