//---------------------------------------------------------------------------

#ifndef portH
#define portH
//---------------------------------------------------------------------------

#include <mmsystem.h>

void CALLBACK TimeProc(UINT, UINT, DWORD, DWORD, DWORD);

class TCasovac {
  MMRESULT timerID;
public:
  bool Started;
  void Start(unsigned int); //v msec
  void Stop();
};

class TPort {
  HANDLE hCom;
  DWORD lpModemStat;
public:
  TPort();
  ~TPort();

  bool Open(char *);
  bool Opened();
  void Close();

  void DTR(bool);
  void RTS(bool);
  void TxD(bool);

  bool CTS();
  bool DSR();
  bool RI();
  bool DCD();
};

void Priorita(short int); //0=realtime; 1=high; 2=normal
void Delayus(unsigned __int64);
void GetData();

#endif
